require 'simple-rss'
require 'open-uri'
require 'pry'

require 'scrapperd/activity'
require 'scrapperd/error'

module Scrapperd
  class Base

    BASE_URL = "http://letterboxd.com/"

    def fetch(username)
      raise Scrapperd::Error::BadRequest.new('options must be in a Hash') unless username
      
      rss = SimpleRSS.parse(open("#{BASE_URL}#{username}/rss"))
      rss.items.map{|item| Scrapperd::Activity.new(item)}
    end
    
  end
end